
/********************************************
****          Ammp  Starter 1.0          ****
**** Copyright 2006, Alessandro Pedretti ****
********************************************/


#include <windows.h>
#include <stdio.h>
#include <string.h>

#define  DXWCPU_C

#include <dxwcpu.h>

#ifdef __BORLANDC__
#  pragma hdrstop
#  pragma argsused
#endif

/**** Constants ****/

#define  AMMP_FILENAME          "ammp.exe"

/**** Prototypes ****/

void            Error(const char *Msg);


/**** Main code ****/

int main(int argc, char* argv[])
{
  char *                        Ptr;
  char *                        Sep;
  char                          PrgPath[MAX_PATH];
  DXWCPU                        Cpu;
  STARTUPINFO                   Si;
  PROCESS_INFORMATION           Pi;

  DXWCPU_GetInfo(&Cpu);
  Ptr = getenv("VEGADIR");
  if (Ptr) {
    strcpy(PrgPath, Ptr);
  } else {
    GetModuleFileName(GetModuleHandle(NULL), PrgPath, MAX_PATH);
    Sep = NULL;
    for(Ptr = PrgPath; *Ptr; ++Ptr)
      if (*Ptr == '\\') Sep = Ptr;
    if (Sep) Sep[1] = 0;
  }
  Ptr = PrgPath + strlen(PrgPath) - 1;
  if (*Ptr != '\\') {
    *++Ptr = '\\';
    *++Ptr = 0;
  } else ++Ptr;
  strcpy(Ptr, AMMP_FILENAME);

  ZeroMemory(&Si, sizeof(STARTUPINFO));
  Si.cb          = sizeof(STARTUPINFO);
  Si.dwFlags     = STARTF_USESHOWWINDOW|STARTF_USESTDHANDLES;
  Si.wShowWindow = SW_HIDE;
  Si.hStdInput   = GetStdHandle(STD_INPUT_HANDLE);
  Si.hStdOutput  = GetStdHandle(STD_OUTPUT_HANDLE);
  Si.hStdError   = GetStdHandle(STD_ERROR_HANDLE);

  if (!DXWCPU_FindFile(&Cpu, PrgPath))
    Error("Can't find the Ammp executable");

  printf("%d %s detected\n"
          "Using %s\n\n", Cpu.m_CPU_Number, Cpu.m_ProcName, Ptr);

  if (!CreateProcess(NULL, PrgPath, NULL, NULL, true, 0, NULL,
                     NULL, &Si, &Pi))
    Error("Can't create the process");

  SetPriorityClass(Pi.hProcess, BELOW_NORMAL_PRIORITY_CLASS);
  WaitForSingleObject(Pi.hProcess, INFINITE);
  CloseHandle(Pi.hProcess);
  CloseHandle(Pi.hThread);

  return 0;
}


/**** Print an error message ****/

void Error(const char *Msg)
{
  fprintf(stderr, "ERROR: %s.\n\n", Msg);

  exit(0);
}
